local function Truncate(value)
	if TidyPlatesThreat.db.profile.text.truncate then
		if value >= 1e6 then
			return format('%.1fm', value / 1e6)
		elseif value >= 1e4 then
			return format('%.1fk', value / 1e3)
		else
			return format('%.1f', value)
		end
	else
		return format('%.1f', value)
	end
end

local function GetHpText(unit)
	local db = TidyPlatesThreat.db.profile.text
	if (not db.full and unit.health == unit.healthmax) then
		return ""
	end

	local HpPct = ""
	local HpAmt = ""
	local HpMax = ""

	if db.amount then
		if db.deficit and unit.health ~= unit.healthmax then
			HpAmt = "-" .. Truncate(unit.healthmax - unit.health)
		else
			HpAmt = Truncate(unit.health)
		end

		if db.max then
			if HpAmt ~= "" then
				HpMax = " / "
			end
			HpMax = HpMax .. Truncate(unit.healthmax)
		end
	end

	if db.percent then
		if HpMax ~= "" or HpAmt ~= "" then
			HpPct = " - "
		end
		local value = 100 * (unit.health / unit.healthmax)
		if value >= 100 then
			HpPct = HpPct .. format('%.0f', value) .. '%'
		else
			HpPct = HpPct .. format('%.1f', value) .. '%'
		end
	end

	return HpAmt .. HpMax .. HpPct
end

local function GetTextSubtitle(unit)
	local DB = TidyPlatesThreat.db.profile.textOnly.customtext

	local text
	if unit.type == "NPC" and DB.showRole then
		text = TidyPlatesUtility.GetUnitSubtitle(unit)
		if text == "UNKNOWN" then text = "" end
	end
	if unit.type == "PLAYER" and DB.showGuild then
		text = GetGuildInfo(unit.unitid)
	end

	local c = DB.color

	return text, c.r, c.g, c.b
end

local function SetCustomText(unit)
	local style = TidyPlatesThreat.SetStyle(unit)
	if style == "text" then
		return GetTextSubtitle(unit)

	else
		return GetHpText(unit)
	end
end

TidyPlatesThreat.SetCustomText = SetCustomText
